unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ComCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    Button1: TButton;
    Edit1: TEdit;
    StringGrid1: TStringGrid;
    Label2: TLabel;
    StatusBar1: TStatusBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses WbemScripting_TLB, activex, comobj, ActiveDS_TLB, adshlp;

procedure findComputers(domain:string; list:TStrings);
var
  ADsTempObj,
  vFilter:  OleVariant;
  Enum:     IEnumVariant;
  Value:    Cardinal;
  DomCont:  IADsContainer;
  Filter:   WideString;
  ADs:      IADs;
begin
  OleCheck(ADsGetObject(PWideChar('WinNT://'+WideUpperCase(domain)), IADsContainer, DomCont));

  Filter := 'Computer';
  VariantInit(vFilter);
  OleCheck(ADsBuildVarArrayStr(@Filter, 1, vFilter));
  DomCont.Set_Filter(vFilter);

  Enum := (Domcont._NewEnum) as IEnumVariant;
  list.Clear;
  while Enum.Next(1, ADsTempObj, Value) = S_OK do
  begin
    if Value = 0 then
      Break;
    ADs := IUnknown(ADsTempObj) as IADs;
    list.Add(ADs.Name);
  end;
end;

procedure findServices(owner:TComponent; machine,user,password:string; names,status:TStrings);
var
  Locator: TSWbemLocator;
  SinkClasses: TSWbemSink;

  Services:   ISWbemServices;
  ObjectSet:  ISWbemObjectSet;
  SObject:    ISWbemObject;
  propSet :   ISWbemPropertySet;
  SProp:      ISWbemProperty;
  propEnum,
  Enum:       IEnumVariant;
  tempObj:    OleVariant;
  Count,
  Value:      Cardinal;

  sValue:     String;
  strQuery:   WideString;
begin
  names.Clear;
  status.clear;
  names.Add('Service Name');
  status.Add('Started?');
  Locator:=TSWbemLocator.Create(owner);
  SinkClasses:=TSWbemSink.Create(owner);

  try
    SinkClasses.Cancel;

    if machine='' then
      machine:='.';// local machine
    Services := Locator.ConnectServer(machine, 'root\CIMV2', user, password, '',
      '', 0, nil);

    ObjectSet := Services.InstancesOf('Win32_Service', wbemFlagReturnImmediately or wbemQueryFlagShallow, nil);

    Enum :=  (ObjectSet._NewEnum) as IEnumVariant;
    while (Enum.Next(1, tempObj, Value) = S_OK) do
    begin
      SObject := IUnknown(tempObj) as SWBemObject;
      propSet := SObject.Properties_;
      propEnum := (propSet._NewEnum) as IEnumVariant;
      while (propEnum.Next(1, tempObj, Value) = S_OK) do
      begin
        SProp := IUnknown(tempObj) as SWBemProperty;
        if (SProp.Name<>'Name') and (SProp.Name<>'Started') then // put any other columns you might be interested here
          continue;
        // now get the value of the property
        sValue := '';
        if VarIsNull(SProp.Get_Value) then
          sValue := '<empty>'
        else
        case SProp.CIMType of
          wbemCimtypeSint8, wbemCimtypeUint8, wbemCimtypeSint16, wbemCimtypeUint16,
          wbemCimtypeSint32, wbemCimtypeUint32, wbemCimtypeSint64:
          if VarIsArray(SProp.Get_Value) then
          begin
            if VarArrayHighBound(SProp.Get_Value, 1) > 0 then
              for Count := 1 to VarArrayHighBound(SProp.Get_Value, 1) do
                sValue := sValue + ' ' + IntToStr(SProp.Get_Value[Count]);
          end
          else
            sValue := IntToStr(SProp.Get_Value);
          wbemCimtypeReal32, wbemCimtypeReal64:
            sValue := FloatToStr(SProp.Get_Value);
          wbemCimtypeBoolean:
            if SProp.Get_Value then
              sValue := 'True'
            else
              sValue := 'False';
          wbemCimtypeString, wbemCimtypeUint64:
          if VarIsArray(SProp.Get_Value) then
          begin
            if VarArrayHighBound(SProp.Get_Value, 1) > 0 then
              for Count := 1 to VarArrayHighBound(SProp.Get_Value, 1) do
                sValue := sValue + ' ' + SProp.Get_Value[Count];
          end
          else
            sValue :=  SProp.Get_Value;
          wbemCimtypeDatetime:
            sValue :=  SProp.Get_Value;
          wbemCimtypeReference:
          begin
            sValue := SProp.Get_Value;
            //This should be better implemented, but will do for now...
            Exception.Create('The result is an array of classes. This kind of data is not yet supported/implemented!');
          end;
          wbemCimtypeChar16:
            sValue := '<16-bit character>';
          wbemCimtypeObject:
            sValue := '<CIM Object>';
        else
            Exception.Create('Unknown type');
        end; {case}

        if SProp.Name='Name' then
          names.Add(sValue);
        if SProp.Name='Started' then
          status.add(sValue);
      end; {while propEnum}
    end; {while Enum}

    strQuery := 'SELECT * FROM __InstanceCreationEvent within 5 WHERE TargetInstance' +
      ' ISA "Win32_Process"';
    Services.ExecNotificationQueryAsync(SinkClasses.DefaultInterface, strQuery, 'WQL', 0, nil, nil);
      strQuery := 'SELECT * FROM __InstanceDeletionEvent within 5 WHERE TargetInstance' +
      ' ISA "Win32_Process"';
    Services.ExecNotificationQueryAsync(SinkClasses.DefaultInterface, strQuery, 'WQL', 0, nil, nil);
  finally
  end; {try}
  Locator.Free;
  SinkClasses.Free;
  Services:=nil;// make sure the references are decreased
  ObjectSet:=nil;
  SObject:=nil;
  propSet:=nil;
  propEnum:=nil;
  SProp:=nil;
  enum:=nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if edit1.text='' then
  begin
    showmessage('must enter a domain/workgroup');
    exit;
  end;
  statusbar1.simpletext:='query network. please wait...';
  try
    findComputers(edit1.text,listbox1.items);
    statusbar1.simpletext:='done. IDLE...';
  except
    on e:exception do
    begin
      showmessage('Error: '+e.message);
      statusbar1.simpletext:='IDLE';
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  stringgrid1.Cols[0].Add('Service Name');
  stringgrid1.Cols[1].Add('Started?');
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var s,t:TStringList;
begin
  if listbox1.ItemIndex>-1 then
  begin
    s:=TStringList.create;
    t:=TStringList.create;
    statusbar1.simpletext:='query WMI. please wait...';
    findServices(self, listbox1.Items[listbox1.itemindex],'','',s,t);
    stringgrid1.RowCount:=s.Count;
    stringgrid1.Cols[0].clear;
    stringgrid1.Cols[1].clear;
    stringgrid1.Cols[0].AddStrings(s);
    stringgrid1.Cols[1].AddStrings(t);
    statusbar1.simpletext:='done. IDLE...';
    s.Free;
    t.Free;
  end;
end;

end.
